<?php
if(!function_exists('sql_table'))	{
	function sql_table($name) {	return 'nucleus_'.$name;	}
}
class NP_Commerce extends NucleusPlugin {
	function getName(){return "Commerce";}
	function getAuthor(){return "jun";}
	function getURL(){return "http://circle.club.or.jp/";}
	function getVersion(){return "0.1";}
	function getDescription(){return "Create Commerce Webite.";}
	function supportsFeature($what) {
		switch($what)	{
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}
	function getEventList() {return array('AddItemFormExtras', 'EditItemFormExtras', 'PostAddItem', 'PreUpdateItem', 'PostDeleteMember', 'PostDeleteItem', 'QuickMenu', 'LoginSuccess');}
	function install() {
//データベース（※一時発注）
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_co_temp').' (
pcotid int(11) unsigned not null, 
pcotcount smallint(6) unsigned NOT NULL, 
pcotip char(15) NOT NULL, 
pcottime datetime NOT NULL, 
pcotcustomid mediumint(8) unsigned, 
pcotpayid tinyint(3) unsigned, 
pcottrans varchar(60), 
pcotnotice text, 
pcotdeliid tinyint(3) unsigned
)');
//データベース（※商品）pcoisizeの前にa-0.2/等を入れると委託。s-200/等を入れると三辺の最大長さ。両方する場合はa-0.2/s-200/
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_co_item').' (
pcoiid int(11) unsigned NOT NULL, 
pcoiprice int(11) unsigned NOT NULL, 
pcoisize varchar(60), 
pcoiweight mediumint(8) unsigned, 
pcoimaker tinyint(3) unsigned, 
pcoitime datetime, 
PRIMARY KEY (pcoiid)
)');
//データベース（※発注仕入棚卸）
		sql_query("CREATE TABLE IF NOT EXISTS ".sql_table('plugin_co_order')." (
pcoono int(11) unsigned, 
pcooid int(11) unsigned NOT NULL, 
pcoocount smallint(6) unsigned NOT NULL, 
pcooprice int(11) unsigned NOT NULL, 
pcootime datetime NOT NULL, 
pcooname varchar(160) NOT NULL,
pcoomaker smallint(6) unsigned,
pcooselect tinyint(2) unsigned
)");
//データベース（※発注リスト）
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_co_list').' (
pcolno int(11) NOT NULL AUTO_INCREMENT, 
pcolcustomid mediumint(8) unsigned NOT NULL, 
pcolprice int(11) unsigned NOT NULL, 
pcolpayid tinyint(3) unsigned NOT NULL, 
pcolpayprice mediumint(8) unsigned NOT NULL, 
pcoltrans varchar(60), 
pcolnotice text, 
pcoletime datetime, 
pcoldeliid tinyint(3) unsigned, 
pcoldeliprice mediumint(8) unsigned, 
PRIMARY KEY (pcolno)
)');
//データベース（※発送先）
		sql_query("CREATE TABLE IF NOT EXISTS ".sql_table('plugin_co_custom')." (
pcocid int(11) unsigned NOT NULL, 
pcocname varchar(60), 
pcockana varchar(60), 
pcocprefectures tinyint(2) unsigned, 
pcocaddress text, 
pcocpost varchar(8), 
pcoctel varchar(15), 
pcocnotice text
)");
//データベース（※支払方法）pcopmodeはa.先払い・b.後払い・c/315-0代引き
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_co_pay').' (
pcopid int(11) unsigned NOT NULL AUTO_INCREMENT, 
pcopmode varchar(100) NOT NULL, 
pcopname varchar(60) NOT NULL, 
pcopyes tinyint(1) unsigned, 
PRIMARY KEY (pcopid)
)');
		mysql_query('INSERT INTO '.sql_table('plugin_co_pay').' VALUES (1, "a", "郵便局振込", 1)');
		mysql_query('INSERT INTO '.sql_table('plugin_co_pay').' VALUES (2, "c/315-0/420-10000/630-30000/1050-100000/2100-300000/3150-500000/4200-1000000", "佐川急便", 1)');
//データベース（※配送方法）pcodmodeはa/定額料金/無料相当買上代金、b/何g-何円/何g-何円、c宅配表
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_co_delivery').' (
pcodid int(11) NOT NULL AUTO_INCREMENT, 
pcodmode varchar(100) NOT NULL, 
pcodname varchar(60) NOT NULL, 
pcodyes tinyint(1) unsigned, 
PRIMARY KEY (pcodid)
)');
		mysql_query('INSERT INTO '.sql_table('plugin_co_delivery').' VALUES (1, "a/800/10000", "宅配便", 1)');
		mysql_query('INSERT INTO '.sql_table('plugin_co_delivery').' VALUES (2, "b/160-0/210-300/310-600/x-1000", "メール便", 0)');
//データベース（※メーカー）
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_co_maker').' (
pcomid smallint(6) NOT NULL AUTO_INCREMENT, 
pcomname varchar(160) NOT NULL, 
pcomurl varchar(100) , 
PRIMARY KEY (pcomid)
)');
		mysql_query('INSERT INTO '.sql_table('plugin_co_maker').' VALUES (1, "日本商事", "")');
		global $CONF;
		$this -> createOption('shop_email', 'ショップE-Mail', 'text', $CONF['AdminEmail']);
		$this -> createOption("shop_address", "署名（※ショップ名・ショップ所在地・電話番号・責任者名など）", "textarea", "ショップ名\nショップ所在地\n電話番号\n責任者名");
		$this -> createOption('shop_bank', '振込先（※複数選択可）', 'textarea', '○×銀行　普通　０１２３４５６７８ \n郵便局　２３１２４１２３４１４１');
		$this -> createOption('shop_ip', 'ＩＰの適用時間 （※単位：時間）', 'text', '2');
		$this -> createOption('shop_zaiko', '在庫管理をしますか？', 'yesno', 'no');
		$this -> createOption('shop_blogid','ｅコマースを使用するブログID（※複数選択可 1/4/5）','text','1');
		$this -> createOption('shop_date_f','更新日のフォーマット（※ Y-m-d H:i:s）','text','Y-m-d H:i:s');
		$this -> createOption('shop_tax1', '税込み処理をしますか？（※税込み処理のみ）', 'yesno', 'yes');
		$this -> createOption('shop_tax2', '消費税率', 'text', '0.05');
		$this -> createOption('shop_tax3', '税額の端数処理　（0.切捨て　1.四捨五入　2.切上げ）', 'text', '0');
		$this -> createOption('del_uninstall', 'アンインストール時にデータベースを削除しますか？', 'yesno', 'no');
		$this -> createOption("quickmenu", '「quick menu」に登録しますか？', 'yesno', 'yes');
	}
	function uninstall() {
		if ($this -> getOption('del_uninstall') == 'yes') {
			mysql_query("DROP table ".sql_table('plugin_co_item'));
			mysql_query("DROP table ".sql_table('plugin_co_custom'));
			mysql_query("DROP table ".sql_table('plugin_co_list'));
			mysql_query("DROP table ".sql_table('plugin_co_order'));
			mysql_query("DROP table ".sql_table('plugin_co_temp'));
			mysql_query("DROP table ".sql_table('plugin_co_pay'));
			mysql_query("DROP table ".sql_table('plugin_co_delivery'));
			mysql_query("DROP table ".sql_table('plugin_co_maker'));
		}
		$this -> deleteOption("shop_email");
		$this -> deleteOption("shop_address");
		$this -> deleteOption("shop_bank");
		$this -> deleteOption("shop_ip");
		$this -> deleteOption("shop_zaiko");
		$this -> deleteOption("shop_blogid");
		$this -> deleteOption("shop_date_f");
		$this -> deleteOption("shop_tax1");
		$this -> deleteOption("shop_tax2");
		$this -> deleteOption("shop_tax3");
		$this -> deleteOption("del_uninstall");
		$this -> deleteOption("quickmenu");
	}
	function getTableList() {
		return array(sql_table('plugin_co_item'), sql_table('plugin_co_custom'), sql_table('plugin_co_list'), sql_table('plugin_co_order'), sql_table('plugin_co_temp'), sql_table('plugin_co_pay'), sql_table('plugin_co_delivery'), sql_table('plugin_co_maker'));
	}
	function event_QuickMenu(&$data) {
		global $member;
		if($this->getOption('quickmenu') != 'yes') return;
		$bids = explode('/', $this -> getOption('shop_blogid'));
			foreach($bids as $bid){
			if($member->isBlogAdmin($bid)) {
				array_push(
				$data['options'],
					array(
						'title' => 'eコマース',
						'url' => $this->getAdminURL(),
						'tooltip' => 'eコマースの管理を行ないます'
					)
				);
			}else {
				array_push(
					$data['options'],
					array(
						'title' => '商品購入画面',
						'url' => $this->getAdminURL(),
						'tooltip' => '商品購入画面へ移動します'
					)
				);
			}
		}
	}
	function hasAdminArea() {	return 1;	}
	function event_AddItemFormExtras($data) {
		?>
			<h3>Commerce</h3>
			<p>
			販売価格：<input name="plugin_co_item_price" size="11" maxlength="11" style="ime-mode:disabled;" value="" />　
			メーカー：<select name="plugin_co_item_maker">
				<option value="" selected="selected">※選択しない</option>
		<?php
			$result = mysql_query('SELECT DISTINCT pcomid, pcomname FROM '.sql_table('plugin_co_maker').' left join '.sql_table('plugin_co_item').' on pcomid = pcoimaker');
			while($row = mysql_fetch_assoc($result)) {
				echo '				<option value="'.$row['pcomid'].'">'.$row['pcomid'].'.'.$row['pcomname'].'</option>';
			}
		?>
			</select></p><p>
			重量：<input name="plugin_co_item_weight" size="6" maxlength="8" style="ime-mode:disabled;" value="" />　
			サイズ：<input name="plugin_co_item_size" size="20" maxlength="60" value="" /></p>
			<p>
			<select name="plugin_co_item_select">
				<option value="1" selected="selected">仕入</option>
				<option value="2">返品</option>
				<option value="3">欠品</option>
				<option value="4">除去</option>
				<option value="5">売上戻</option>
				<option value="6">期首棚卸</option>
				<option value="7">e売上</option>
				<option value="8">r売上</option>
			</select>　
			数量：<input name="plugin_co_item_zaiko" size="6" maxlength="6" style="ime-mode:disabled;" value="" />　
			仕入価格：<input name="plugin_co_item_shiire" size="11" maxlength="11" style="ime-mode:disabled;" value="" />
			</p>
		<?php
	}
	function event_EditItemFormExtras($data) {
		global $itemid;
		?>
			<h3>Commerce</h3>
			<p>
<?php
		$q1 = mysql_query('SELECT pcoiprice, pcoiweight, pcoisize FROM '.sql_table('plugin_co_item').' WHERE pcoiid = '.$itemid);
		while($row = mysql_fetch_assoc($q1)) {
			$pcoiprice = $row['pcoiprice'];
			$pcoiweight = $row['pcoiweight'];
			$pcoisize = $row['pcoisize'];
		}
		echo '
			販売価格：<input name="plugin_co_item_price" size="11" maxlength="11" style="ime-mode:disabled;" value="'.$pcoiprice.'" />　
			メーカー：<select name="plugin_co_item_maker">
<option value="">※選択しない</option>';
		$result = mysql_query('SELECT DISTINCT pcomid, pcomname FROM '.sql_table('plugin_co_maker').' left join '.sql_table('plugin_co_item').' on pcomid = pcoimaker');
		while($row = mysql_fetch_assoc($result)) {
			$mid = quickQuery('SELECT pcoimaker as result FROM '.sql_table('plugin_co_item').' WHERE pcoiid = '.$itemid);
			$flag = ($row['pcomid'] == $mid) ? ' selected="selected"' : '';
			echo '<option value="'.$row['pcomid'].'" '.$flag.'>'.$row['pcomid'].'.'.$row['pcomname'].'</option>';
		}
		echo '</select></p><p>
			重量：<input name="plugin_co_item_weight" size="6" maxlength="8" style="ime-mode:disabled;" value="'.$pcoiweight.'" />　
			サイズ：<input name="plugin_co_item_size" size="20" maxlength="60" value="'.$pcoisize.'" /></p>
			<p>';
		require("commerce/value/zaiko.php");
		if($zaiko) echo '在庫：'.$zaiko.'個　';
		echo '<select name="plugin_co_item_select">
				<option value="1" selected="selected">仕入</option>
				<option value="2">返品</option>
				<option value="3">欠品</option>
				<option value="4">除去</option>
				<option value="5">売上戻</option>
				<option value="6">期首棚卸</option>
				<option value="7">e売上</option>
				<option value="8">r売上</option>
			</select>　
			数量：<input name="plugin_co_item_zaiko" size="6" maxlength="6" style="ime-mode:disabled;" value="" />　
			仕入価格：<input name="plugin_co_item_shiire" size="11" maxlength="11" style="ime-mode:disabled;" value="" /></p>';
	}
	function event_PostAddItem($data) {
		$itemid = $data['itemid'];
		$pcooname = quickQuery('SELECT ititle as result FROM '.sql_table('item').' WHERE inumber = '.$itemid);
		$pcoiprice = addslashes(requestVar('plugin_co_item_price'));
		$pcoisize = addslashes(requestVar('plugin_co_item_size'));
		$pcoiweight = addslashes(requestVar('plugin_co_item_weight'));
		$pcoimaker = addslashes(requestVar('plugin_co_item_maker'));
		$pcooselect = addslashes(requestVar('plugin_co_item_select'));
		$pcoocount = addslashes(requestVar('plugin_co_item_zaiko'));
		$pcooprice = addslashes(requestVar('plugin_co_item_shiire'));
		$pcootime = date("Y-m-d H:i:s");
		if($pcoocount) sql_query('INSERT INTO '.sql_table('plugin_co_order')." (pcoono, pcooid, pcoocount, pcooprice, pcootime, pcooname, pcoomaker, pcooselect) VALUES (0, '$itemid', '$pcoocount', '$pcooprice', '$pcootime', '$pcooname', '$pcoimaker', '$pcooselect')");
		if($pcoiprice) sql_query('INSERT INTO '.sql_table('plugin_co_item')." (pcoiid, pcoiprice, pcoiweight, pcoisize, pcoimaker) VALUES ('$itemid', '$pcoiprice', '$pcoiweight', '$pcoisize', '$pcoimaker')");
		return;
	}
	function event_PreUpdateItem($data) {
		global $itemid;
		$pcooname = quickQuery('SELECT ititle as result FROM '.sql_table('item').' WHERE inumber = '.$itemid);
		$pcoiprice = addslashes(requestVar('plugin_co_item_price'));
		$pcoisize = addslashes(requestVar('plugin_co_item_size'));
		$pcoiweight = addslashes(requestVar('plugin_co_item_weight'));
		$pcoimaker = addslashes(requestVar('plugin_co_item_maker'));
		$pcooselect = addslashes(requestVar('plugin_co_item_select'));
		$pcoocount = addslashes(requestVar('plugin_co_item_zaiko'));
		$pcooprice = addslashes(requestVar('plugin_co_item_shiire'));
		$pcottime = date("Y-m-d H:i:s");
		if($pcoocount) sql_query('INSERT INTO '.sql_table('plugin_co_order')." (pcoono, pcooid, pcoocount, pcooprice, pcootime, pcooname, pcoomaker, pcooselect) VALUES (0, '$itemid', '$pcoocount', '$pcooprice', '$pcottime', '$pcooname', '$pcoimaker', '$pcooselect')");
		sql_query('DELETE FROM '.sql_table('plugin_co_item')." WHERE pcoiid = ".$itemid);
		sql_query('INSERT INTO '.sql_table('plugin_co_item')." (pcoiid, pcoiprice, pcoiweight, pcoisize, pcoimaker, pcoitime) VALUES ('$itemid', '$pcoiprice', '$pcoiweight', '$pcoisize', '$pcoimaker', '$pcottime')");
		return;
	}
	function event_PostDeleteMember($data) {
		$member = $data['member'];
		if($member) {
			$memid = $member -> getID();
			mysql_query('DELETE FROM '.sql_table('plugin_co_custom')." WHERE pcocid = ".$memid);
		}
		return;
	}
	function event_PostDeleteItem($data) {
		global $itemid;
		mysql_query('DELETE FROM '.sql_table('plugin_co_item')." WHERE pcoiid = ".$itemid);
		mysql_query('DELETE FROM '.sql_table('plugin_co_temp')." WHERE pcotid = ".$itemid);
		return;
	}
	function event_LoginSuccess($data) {
		global $CONF, $manager, $member;
		$memid = $member -> getID();
		$pcotip = ServerVar('REMOTE_ADDR');
		$pcottime = date("Y-m-d H:i:s");
		sql_query("UPDATE ".sql_table('plugin_co_temp')." SET pcotcustomid = '".$memid."', pcottime = '".$pcottime."' WHERE pcotip = '".$pcotip."'");
		return;
	}
	function doSkinVar($skinType, $mode = '') {
		require("commerce/temp.php");
	}
	function doTemplateVar(&$item, $what = '', $mode = '') {
		global $CONF, $member;
    $itemid = $item -> itemid;
		require("commerce/value/zaiko.php");
		if($what == 'zaiko' && $zaiko) echo '在庫：'.$zaiko.'個　';
		$q5 = mysql_query('SELECT pcoiprice, pcoiweight, pcoisize, UNIX_TIMESTAMP(pcoitime) as pcoitime, pcomname, pcomurl, pcotcount FROM '.sql_table('plugin_co_item').' left join '.sql_table('plugin_co_maker').' on pcoimaker = pcomid left join '.sql_table('plugin_co_temp').' on pcotid = '.$itemid.' WHERE pcoiid = '.$itemid);
		while($row = mysql_fetch_assoc($q5)) {
			if(!$row['pcoiprice']) return;
			$scatid = quickQuery('SELECT subcategories as result FROM '.sql_table('plug_multiple_categories').' WHERE item_id = '.$itemid);
			$pcotcount = ($row['pcotcount']) ? $row['pcotcount'] : 1;
			if($what == 'price') {
				$view = '価格：'.number_format($row['pcoiprice'])."円　";
			}elseif($what == 'weight' && $row['pcoiweight']) {
				$view = '重さ：'.number_format($row['pcoiweight'])."ｇ　".$zmode;
			}elseif($what == 'size' && $row['pcoisize']) {
				$view = 'サイズ：'.$row['pcoisize']."　";
			}elseif($what == 'maker' && $row['pcomname']) {
				$view = 'メーカー：'.$row['pcomname']."　";
			}elseif($what == 'time' && $row['pcoitime'] > 0) {
				$view = '更新日：'.date($this -> getOption('shop_date_f'), $row['pcoitime']);
			}elseif($what == 'murl') {
				$view = $row['pcomurl'];
			}elseif($what == 'aurl') {
				$view = $CONF['AdminURL'].'plugins/commerce/';
			}elseif($what == 'choise') {
				if($this->getOption('shop_zaiko') == 'yes' && !$zaiko) {
					$view = '(※在庫切れ)<br />';
				}else {
					$view = '<form method="get" action="'.$_SERVER['PHP_SELF'].'">
<input name="itemid" type="hidden" value="'.$itemid.'" /> 
<input name="subcatid" type="hidden" value="'.$scatid.'" /> 
数量：<input name="count" size="3" maxlength="3" value="'.$pcotcount.'" style="ime-mode:disabled;" /> 
<input type="submit" name="choise" value="カゴに入れる" />
</form>';
				}
			}elseif($what == 'quick' && !($this->getOption('shop_zaiko') == 'yes' && !$zaiko)) {
				$view = '<a href="'.$_SERVER['PHP_SELF'].'?itemid='.$itemid.'&amp;subcatid='.$scatid.'&amp;count=1&amp;choise=1"><img src="'.$CONF['AdminURL'].'plugins/commerce/value/img/c_icon.jpg" height="12" width="15" title="カゴに入れる（*'.number_format($row['pcoiprice']).'円）" /></a>';
			}elseif($what == 'regi') {
				$view = '<a href="'.$CONF['AdminURL'].'plugins/commerce/"><img src="'.$CONF['AdminURL'].'plugins/commerce/value/img/imas.jpg" height="20" width="20" title="レジへ進む" />レジへ</a>';
			}
		}
		echo $view;
	}
}
?>